Attribute VB_Name = "PhVintSetup"
Option Explicit

   ' Create a TYPE for the data required for each I/O point
   Public Type ChInfo
      ' Values entered by user
      devName As String    ' Device Name
      devClass As String   ' DigOut, DigInp, Encoder, Stepper
      hubSn As Long        ' Nbr on back of Hub
      isHub As Long        ' 1 if using Hub Port as I/O point
      port As Long         ' Hub Port number
      ch As Long           ' Module channel number (0 if Hub)
      
      ' The following value is created by program
      hndl As Long         ' Handle is created with 'Create device'
   End Type
      
   ' Make an array large enough for all I/O points
   Public Dev(59) As ChInfo ' Hub=0, Port=0-5, Channel=0-9
   Public Const VintTimeOutMs& = 500
   
   Public Stepper01Index%
   Public Stepper02Index%
   Public LcdDisplayIndex%
   Public EncoderIndex%
   Public DigOut01Index%
   Public CurInpIndex%
   
   Public RelOut00Index%
   Public RelOut01Index%
   Public RelOut02Index%
   Public RelOut03Index%
   
   ' Typical C++ data type for VINT (from Phidgets C++ example)
   '
   '   Public Type NetInfo
   '      isRemote As Long
   '      serverDiscovery As Long
   '      hostName As String
   '      netPort As Long
   '      password As String
   '   End Type
   '
   '   Public Type ChInfo
   '      deviceSerialNumber As Long
   '      hubPort As Long
   '      channel As Long
   '      isHub As Long  ' Is this a Hub Port device
   '      isVINT As Long ' Is this a VINT device
   '      netInf As NetInfo
   '   End Type

' ===========================================================================
Public Static Sub SetupAllPhidgets()
   ' User setup data
   ' Enter SN#, isHub, port, and ch for each I/O point
   
   Dim stat&
   Dim indx&
   ' Each I/O point is given an index number.  This is passed to the
   ' Phiget22 DLL (as userData) when the callbacks (events) are set up.
   ' When an event occurs, the handle and index (userData) are sent
   ' back to the callback routine (eg. OnError) and used as as the
   ' ChInfo() index to reference which I/O point the event belongs to.
   
   Stepper01Index% = 0
   Stepper02Index% = 10
   LcdDisplayIndex% = 20
   CurInpIndex% = 30
   'EncoderIndex% = 30
   DigOut01Index% = 40
   
   RelOut00Index% = 50
   RelOut01Index% = 51
   RelOut02Index% = 52
   RelOut03Index% = 53
   
   ' =================================================
   ' Setup Hub 0, Port 0, Channel 0 for STC1001 Stepper 0
   indx& = Stepper01Index%
   Dev(indx&).devName = "Stepper 000"    ' Enter name of device
   Dev(indx&).devClass = "Stepper"     ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 0                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhStepper(indx&, stat&)    ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 1, Channel 0 for STC1001 Stepper 1
   ' Setup VINT Hub hubPort for STC1001 Stepper 1
   indx& = Stepper02Index%
   Dev(indx&).devName = "Stepper 010"  ' Enter name of device
   Dev(indx&).devClass = "Stepper"     ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 1                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhStepper(indx&, stat&)    ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 2, Channel 0 for LCD Display Module
   indx& = LcdDisplayIndex%
   Dev(indx&).devName = "Lcd 020"      ' Enter name of device
   Dev(indx&).devClass = "Lcd"         ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 2                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhLcd(indx&, stat&)        ' Create Dev(indx&).hndl
   
'   ' =================================================
'   ' Setup Hub 0, Port 3, Channel 0 for ENC1000 Encoder
'   indx& = EncoderIndex%
'   Dev(indx&).devName = "Encoder 030"  ' Enter name of device
'   Dev(indx&).devClass = "Encoder"     ' Enter class of device
'   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
'   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
'   Dev(indx&).port = 3                 ' Hub port (0-5)
'   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
'   Call InitPhEncoder(indx&, stat&)    ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 3, Channel 0 for VCP1100 Current Input
   indx& = CurInpIndex%
   Dev(indx&).devName = "CurInp 030"  ' Enter name of device
   Dev(indx&).devClass = "CurInp"     ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Enter SN# for YOUR hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 3                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhCurInp(indx&, stat&)    ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 4, Channel 0 for Local Output 1
   indx& = DigOut01Index%
   Dev(indx&).devName = "DigOut 040"   ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' Serial number for MY hub
   Dev(indx&).isHub = 1                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 4                 ' Hub port (0-5)
   Dev(indx&).ch = 0                   ' Channel (Hub is always 0)
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 5, Channel 0 for Relay Output 0
   indx& = RelOut00Index%
   Dev(indx&).devName = "RelOut 050"   ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' SN# for hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 5                 ' Hub port number (0-5)
   Dev(indx&).ch = 0                   ' Module channel or 0 for Hub
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 5, Channel 1 for Relay Output 1
   indx& = RelOut01Index%
   Dev(indx&).devName = "RelOut 051"   ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' SN# for hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 5                 ' Hub port number (0-5)
   Dev(indx&).ch = 1                   ' Module channel or 0 for Hub
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 5, Channel 2 for Relay Output 2
   indx& = RelOut02Index%
   Dev(indx&).devName = "RelOut 052"   ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' SN# for hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 5                 ' Hub port number (0-5)
   Dev(indx&).ch = 2                   ' Module channel or 0 for Hub
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
   ' =================================================
   ' Setup Hub 0, Port 5, Channel 3 for Relay Output 3
   indx& = RelOut03Index%
   Dev(indx&).devName = "RelOut 053"   ' Enter name of device
   Dev(indx&).devClass = "DigOut"      ' Enter class of device
   Dev(indx&).hubSn = 527576           ' SN# for hub
   Dev(indx&).isHub = 0                ' Located on hub (0=No 1=Yes)
   Dev(indx&).port = 5                 ' Hub port number (0-5)
   Dev(indx&).ch = 3                   ' Module channel or 0 for Hub
   Call InitPhDigOut(indx&, stat&)     ' Create Dev(indx&).hndl
   
End Sub

'===========================================================================
Public Static Sub CloseAllPhidgets()
   ' Close (if attached) and Delete all Created channels.
   ' Devices (channels) are created using their "class".  They
   ' are also be deleted by class.  The devClass is set during
   ' entry of setup pramaters.
  
   Dim indx&
   Dim stat&
   Dim attached&
   
   On Error Resume Next
   
   For indx& = 0 To 59 ' Skips devices not used ' Hub 0 only
                       ' If using 2 Hubs then use (indx& = 0 to 159)
      Select Case Dev(indx&).devClass
         Case "DigOut"
            stat& = PhGetAttached&(Dev(indx&).hndl, attached&)
            If attached& = 1 Then stat& = PhClose(Dev(indx&).hndl)
            stat& = PhDigOutDelete&(Dev(indx&).hndl)
            DoEvents
            Sleep 50
         Case "DigInp"
            stat& = PhGetAttached&(Dev(indx&).hndl, attached&)
            If attached& = 1 Then stat& = PhClose(Dev(indx&).hndl)
            stat& = PhDigInpDelete&(Dev(indx&).hndl)
            DoEvents
            Sleep 50
         Case "Encoder"
            stat& = PhGetAttached&(Dev(indx&).hndl, attached&)
            If attached& = 1 Then stat& = PhClose(Dev(indx&).hndl)
            stat& = PhEncDelete&(Dev(indx&).hndl)
            DoEvents
            Sleep 50
         Case "Stepper"
            stat& = PhGetAttached&(Dev(indx&).hndl, attached&)
            If attached& = 1 Then stat& = PhClose(Dev(indx&).hndl)
            stat& = PhStepDelete&(Dev(indx&).hndl)
            DoEvents
            Sleep 50
         Case "CurInp"
            stat& = PhGetAttached&(Dev(indx&).hndl, attached&)
            If attached& = 1 Then stat& = PhClose(Dev(indx&).hndl)
            stat& = PhCurInpDelete&(Dev(indx&).hndl)
            DoEvents
            Sleep 50
         Case "Lcd"
            stat& = PhGetAttached&(Dev(indx&).hndl, attached&)
            If attached& = 1 Then stat& = PhClose(Dev(indx&).hndl)
            stat& = PhLcdDelete&(Dev(indx&).hndl)
            DoEvents
            Sleep 50
      End Select ' Dev(indx&).devClass
      
   Next indx&

   Sleep 300 ' Allow some time to close before ending (avoid crash)

End Sub
   
   

